﻿using Infragistics.Win.UltraWinTree;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WindowsFormsHostTest
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        UltraTree tree;
        public MainWindow()
        {
            InitializeComponent();

            DataTable table = new DataTable();
            table.Columns.Add(new DataColumn("Col1"));

            for(int i=0; i<50; i++)
            {
                DataRow row = table.NewRow();
                row[0] = "Ultra Tree Node " + i.ToString();
                table.Rows.Add(row);
            }

            tree = new UltraTree();
            tree.DataSource = table;
            tree.Override.NodeStyle = NodeStyle.CheckBox;
            tree.ViewStyle = ViewStyle.Standard;
            tree.Override.AllowAutoDragExpand = AllowAutoDragExpand.ExpandOnDragHover;

            tree.Override.TipStyleNode = TipStyleNode.Show;
            tree.ColumnSettings.TipStyleCell = TipStyleCell.Show;
            tree.AllowDrop = true;

            tree.Override.SelectionType = SelectType.Single;

            tree.MouseMove += Tree_MouseMove;
            tree.DragEnter += Tree_DragEnter;
            tree.DragDrop += Tree_DragDrop;

            winFormsHost.Child = tree;
        }


        int count = 0;
        private void Tree_MouseMove(object sender, System.Windows.Forms.MouseEventArgs e)
        {
            System.Diagnostics.Debug.WriteLine(e.Button);
            if (tree.SelectedNodes.Count != 0 && e.Button == System.Windows.Forms.MouseButtons.Left)
            {
                tree.DoDragDrop(tree.SelectedNodes[0].Text, System.Windows.Forms.DragDropEffects.Copy);
            }
            count++;
        }

        private void Tree_DragDrop(object sender, System.Windows.Forms.DragEventArgs e)
        {
            System.Drawing.Point point = tree.PointToClient(new System.Drawing.Point(e.X, e.Y));
            UltraTreeNode node = tree.GetNodeFromPoint(point);
            
            string str = e.Data.GetData(DataFormats.Text).ToString();
            node.SetCellValue(tree.ColumnSettings.ColumnSets[0].Columns[0], str);
            node.Update();            
        }

        private void Tree_DragEnter(object sender, System.Windows.Forms.DragEventArgs e)
        {
            e.Effect = System.Windows.Forms.DragDropEffects.Copy;
        }     
    }
}
